バイナリー・ファイルzabbix-1.8.16/frontends/php/include/locales/.ja_jp.inc.php.swpとzabbix-1.8.16_v3patched/frontends/php/include/locales/.ja_jp.inc.php.swpは違います
diff -uNrp zabbix-1.8.16/frontends/php/include/locales/ja_jp.inc.php zabbix-1.8.16_v3patched/frontends/php/include/locales/ja_jp.inc.php
--- zabbix-1.8.16/frontends/php/include/locales/ja_jp.inc.php	2013-02-08 06:59:44.590046292 +0900
+++ zabbix-1.8.16_v3patched/frontends/php/include/locales/ja_jp.inc.php	2013-02-08 07:28:18.025894463 +0900
@@ -23,7 +23,7 @@
 
 	$TRANSLATION=array(
 
-	'S_DATE_FORMAT_YMDHMS'=>			'Y M d H:i:s',
+	'S_DATE_FORMAT_YMDHMS'=>			'J M j H:i:s',
 	'S_HTML_CHARSET'=>			'UTF-8',
 	'S_YEAR_SHORT'=>			'y',
 	'S_MONTH_SHORT'=>			'm',
@@ -134,8 +134,8 @@
 	'S_DISCOVERED_DEVICE'=>			'発見されたホスト',
 	'S_MONITORED_HOST'=>			'監視中のホスト',
 	'S_INCORRECT_IP_RANGE'=>			'IPアドレスの範囲が正しくありません',
-	'S_AUDITACTS_DESCRIPTION_DATE_FORMAT'=>			'Y M d H:i:s',
-	'S_AUDITLOGS_RECORD_DATE_FORMAT'=>			'Y M d H:i:s',
+	'S_AUDITACTS_DESCRIPTION_DATE_FORMAT'=>			'J M j H:i:s',
+	'S_AUDITLOGS_RECORD_DATE_FORMAT'=>			'J M j H:i:s',
 	'S_DETAILS_OF_SCENARIO'=>			'シナリオの名前',
 	'S_DETAILS_OF_SCENARIO_BIG'=>			'シナリオの名前',
 	'S_SPEED'=>			'スピード',
@@ -152,8 +152,8 @@
 	'S_STATUS_OF_WEB_MONITORING'=>			'ウェブ監視のステータス',
 	'S_STATUS_OF_WEB_MONITORING_BIG'=>			'ウェブ監視のステータス',
 	'S_STATE'=>			'ステータス',
-	'S_WEB_SCENARIO_DATE_FORMAT'=>			'Y M d H:i:s',
-	'S_WEB_SCENARIO_IDLE_DATE_FORMAT'=>			'Y M d H:i:s',
+	'S_WEB_SCENARIO_DATE_FORMAT'=>			'J M j H:i:s',
+	'S_WEB_SCENARIO_IDLE_DATE_FORMAT'=>			'J M j H:i:s',
 	'S_SORT'=>			'ソート',
 	'S_STATUS_CODES'=>			'ステータスコード',
 	'S_WEB'=>			'ウェブ',
@@ -219,9 +219,9 @@
 	'S_INSTALLATION_UPDATE'=>			'インストール/更新',
 	'S_ZABBIX_IS_UNAVAILABLE'=>			'Zabbixは一時的に利用できません',
 	'S_REQUIRE_MB_STRING_MODULE'=>			'フロントエンドの動作にはマルチバイトモジュールが必要です',
-	'S_HISTORY_OF_ACTIONS_DATE_FORMAT'=>			'Y M d H:i:s',
-	'S_EVENT_ACTION_MESSAGES_DATE_FORMAT'=>			'Y M d H:i:s',
-	'S_EVENT_ACTION_CMDS_DATE_FORMAT'=>			'Y.M.d H:i:s',
+	'S_HISTORY_OF_ACTIONS_DATE_FORMAT'=>			'J M j H:i:s',
+	'S_EVENT_ACTION_MESSAGES_DATE_FORMAT'=>			'J M j H:i:s',
+	'S_EVENT_ACTION_CMDS_DATE_FORMAT'=>			'JMj H:i:s',
 	'S_INCORRECT_PARAMETER_USED_FOR_CONDITIONS'=>			'コンディションのパラメータが正しくありません',
 	'S_INCORRECT_PARAMETER_USED_FOR_OPERATIONS'=>			'オペレーションのパラメータが正しくありません',
 	'S_INCORRECT_PARAMETER_USED_FOR_ACTION'=>			'アクションのパラメータが正しくありません',
@@ -250,8 +250,8 @@
 	'S_CANNOT_ACKNOWLEDGE_EVENT'=>			'イベントの障害対応コメントを入力できません',
 	'S_SYS_BULK_ACKNOWLEDGE'=>			'----[障害対応コメントの一括処理]----',
 	'S_BULK_ACKNOWLEDGE'=>			'障害対応コメントの一括処理',
-	'S_ACKNOWLEDGE_DATE_FORMAT'=>			'Y M d H:i:s',
-	'S_ACKNOWINC_BY_EVENTS_DATE_FORMAT'=>			'Y M d H:i:s',
+	'S_ACKNOWLEDGE_DATE_FORMAT'=>			'J M j H:i:s',
+	'S_ACKNOWINC_BY_EVENTS_DATE_FORMAT'=>			'J M j H:i:s',
 	'S_IMMEDIATELY'=>			'すぐに',
 	'S_INFINITY'=>			'無限',
 	'S_RECOVERY_MESSAGE'=>			'リカバリメッセージ',
@@ -392,13 +392,13 @@
 	'S_VIEW'=>			'ビュー',
 	'S_CCHARTS_TIMELINE_HOURS_FORMAT'=>			'H:i',
 	'S_CCHARTS_TIMELINE_DAYS_FORMAT'=>			'D',
-	'S_CCHARTS_TIMELINE_MONTHDAYS_FORMAT'=>			'm.d',
-	'S_CCHARTS_TIMELINE_START_DATE_FORMAT'=>			'm.d H:i',
-	'S_CCHARTS_TIMELINE_END_DATE_FORMAT'=>			'm.d H:i',
+	'S_CCHARTS_TIMELINE_MONTHDAYS_FORMAT'=>			'Mj',
+	'S_CCHARTS_TIMELINE_START_DATE_FORMAT'=>			'Mj H:i',
+	'S_CCHARTS_TIMELINE_END_DATE_FORMAT'=>			'Mj H:i',
 	'S_CCHARTS_TIMELINE_MAINPERIOD_HOURS_FORMAT'=>			'H:i',
-	'S_CCHARTS_TIMELINE_MAINPERIOD_FULL_DAY_TIME_FORMAT'=>			'm.d H:i',
-	'S_CCHARTS_TIMELINE_MAINPERIOD_MONTHDAYS_FORMAT'=>			'm.d',
-	'S_CUSER_ERROR_DATE_FORMAT'=>			'Y.m.d H:i',
+	'S_CCHARTS_TIMELINE_MAINPERIOD_FULL_DAY_TIME_FORMAT'=>			'Mj H:i',
+	'S_CCHARTS_TIMELINE_MAINPERIOD_MONTHDAYS_FORMAT'=>			'Mj',
+	'S_CUSER_ERROR_DATE_FORMAT'=>			'JMj H:i',
 	'S_GUI'=>			'表示設定',
 	'S_DROPDOWN_FIRST_ENTRY'=>			'ドロップダウンの1つ目の項目',
 	'S_DROPDOWN_REMEMBER_SELECTED'=>			'選択を記憶',
@@ -650,11 +650,11 @@
 	'S_AS_BLUE'=>			'as Blue',
 	'S_FAILURE_AUDIT'=>			'失敗の監査',
 	'S_SUCCESS_AUDIT'=>			'成功の監査',
-	'S_HISTORY_LOG_ITEM_DATE_FORMAT'=>			'[Y.M.d H:i:s]',
-	'S_HISTORY_LOG_LOCALTIME_DATE_FORMAT'=>			'Y.M.d H:i:s',
+	'S_HISTORY_LOG_ITEM_DATE_FORMAT'=>			'[JMj H:i:s]',
+	'S_HISTORY_LOG_LOCALTIME_DATE_FORMAT'=>			'JMj H:i:s',
 	'S_HISTORY_LOG_ITEM_PLAINTEXT'=>			'Y-m-d H:i:s',
 	'S_HISTORY_PLAINTEXT_DATE_FORMAT'=>			'Y-m-d H:i:s',
-	'S_HISTORY_ITEM_DATE_FORMAT'=>			'Y.M.d H:i:s',
+	'S_HISTORY_ITEM_DATE_FORMAT'=>			'JMj H:i:s',
 	'S_MAINTENANCE'=>			'メンテナンス',
 	'S_MAINTENANCE_ADDED'=>			'メンテナンスを追加しました',
 	'S_MAINTENANCE_UPDATED'=>			'メンテナンスを更新しました',
@@ -1065,20 +1065,20 @@
 	'S_LATEST_EVENTS'=>			'最新のイベント',
 	'S_HISTORY_OF_EVENTS_BIG'=>			'イベント履歴',
 	'S_NO_EVENTS_FOUND'=>			'イベントが見つかりません',
-	'S_EVENTS_DATE_FORMAT'=>			'Y M d H:i:s',
-	'S_EVENTS_DISCOVERY_TIME_FORMAT'=>			'Y.M.d H:i:s',
-	'S_EVENTS_ACTION_TIME_FORMAT'=>			'Y.M.d H:i:s',
+	'S_EVENTS_DATE_FORMAT'=>			'J M j H:i:s',
+	'S_EVENTS_DISCOVERY_TIME_FORMAT'=>			'JMj H:i:s',
+	'S_EVENTS_ACTION_TIME_FORMAT'=>			'JMj H:i:s',
 	'S_UP_BIG'=>			'UP',
 	'S_DOWN_BIG'=>			'DOWN',
 	'S_DISCOVERED_BIG'=>			'DISCOVERED',
 	'S_LOST_BIG'=>			'LOST',
-	'S_EVENTS_EVENT_DETAILS_DATE_FORMAT'=>			'Y.M.d H:i:s',
-	'S_EVENTS_SMALL_EVENT_LIST_DATE_FORMAT'=>			'Y.M.d H:i:s',
-	'S_EVENTS_POPUP_EVENT_LIST_DATE_FORMAT'=>			'Y M d H:i:s',
-	'S_EVENTS_TRIGGERS_EVENTS_HISTORY_LIST_DATE_FORMAT'=>			'Y.M.d H:i:s',
+	'S_EVENTS_EVENT_DETAILS_DATE_FORMAT'=>			'JMj H:i:s',
+	'S_EVENTS_SMALL_EVENT_LIST_DATE_FORMAT'=>			'JMj H:i:s',
+	'S_EVENTS_POPUP_EVENT_LIST_DATE_FORMAT'=>			'j M j H:i:s',
+	'S_EVENTS_TRIGGERS_EVENTS_HISTORY_LIST_DATE_FORMAT'=>			'JMj H:i:s',
 	'S_LAST_CHECK'=>			'最新のチェック',
 	'S_LAST_VALUE'=>			'最新の値',
-	'S_LATEST_ITEMS_TRIGGERS_DATE_FORMAT'=>			'Y M d H:i:s',
+	'S_LATEST_ITEMS_TRIGGERS_DATE_FORMAT'=>			'J M j H:i:s',
 	'S_HIDDEN'=>			'非表示',
 	'S_SHOWN'=>			'表示',
 	'S_ALIGN_ICONS'=>			'グリッドに揃える',
@@ -1166,7 +1166,7 @@
 	'S_ELEMENT_NAME'=>			'アイコン名',
 	'S_STATUS_ONLY'=>			'ステータスのみ',
 	'S_NOTHING'=>			'なし',
-	'S_MAPS_DATE_FORMAT'=>			'Y.m.d H:i:s',
+	'S_MAPS_DATE_FORMAT'=>			'Jmj H:i:s',
 	'S_CONFIGURATION_OF_MEDIA_TYPES_BIG'=>			'メディアタイプの設定',
 	'S_MEDIA_TYPES_BIG'=>			'メディアタイプ',
 	'S_MEDIA'=>			'メディア',
@@ -1231,7 +1231,7 @@
 	'S_MORE_THAN_10_MINUTES'=>			'10分以上',
 	'S_TRUNCATED'=>			'Truncated',
 	'S_DELAYED_BY'=>			'遅延時間',
-	'S_QUEUE_NODES_DATE_FORMAT'=>			'Y M d H:i:s',
+	'S_QUEUE_NODES_DATE_FORMAT'=>			'J M j H:i:s',
 	'S_REPORT_BIG'=>			'レポート',
 	'S_STATUS_OF_ZABBIX'=>			'Zabbixサーバの状態',
 	'S_STATUS_OF_ZABBIX_BIG'=>			'Zabbixサーバの状態',
@@ -1262,11 +1262,11 @@
 	'S_CHART4_HEADER_TITLE_PART2'=>			'(year',
 	'S_CHART4_HEADER_TITLE_PART3'=>			')',
 	'S_CHART4_HEADER_DATE_FORMAT'=>			'Y',
-	'S_CHART4_TIMELINE_DATE_FORMAT'=>			'M.d',
+	'S_CHART4_TIMELINE_DATE_FORMAT'=>			'Mj',
 	'S_CHART5_HEADER_TITLE_PART2'=>			'(year',
 	'S_CHART5_HEADER_TITLE_PART3'=>			')',
 	'S_CHART5_HEADER_DATE_FORMAT'=>			'Y',
-	'S_CHART5_TIMELINE_DATE_FORMAT'=>			'M.d',
+	'S_CHART5_TIMELINE_DATE_FORMAT'=>			'Mj',
 	'S_CHARTBAR_HOURLY_DATE_FORMAT'=>			'Y.m.d H:i',
 	'S_CHARTBAR_DAILY_DATE_FORMAT'=>			'Y.m.d',
 	'S_IT_SERVICES_AVAILABILITY_REPORT'=>			'ITサービス稼働レポート',
@@ -1293,13 +1293,13 @@
 	'S_WEEKLY'=>			'毎週',
 	'S_MONTHLY'=>			'毎月',
 	'S_YEARLY'=>			'毎年',
-	'S_REPORT3_ANNUALLY_DATE_FORMAT'=>			'Y',
-	'S_REPORT3_MONTHLY_DATE_FORMAT'=>			'Y M',
-	'S_REPORT3_DAILY_DATE_FORMAT'=>			'Y M d',
-	'S_REPORT3_WEEKLY_DATE_FORMAT'=>			'Y M d H:i',
+	'S_REPORT3_ANNUALLY_DATE_FORMAT'=>			'J',
+	'S_REPORT3_MONTHLY_DATE_FORMAT'=>			'J M',
+	'S_REPORT3_DAILY_DATE_FORMAT'=>			'J M j',
+	'S_REPORT3_WEEKLY_DATE_FORMAT'=>			'J M j H:i',
 	'S_SERVICES_UPTIME_DATE_FORMAT'=>			'l H:i',
 	'S_SERVICES_DOWNTIME_DATE_FORMAT'=>			'l H:i',
-	'S_SERVICES_ONETIME_DOWNTIME_DATE_FORMAT'=>			'Y M d H:i',
+	'S_SERVICES_ONETIME_DOWNTIME_DATE_FORMAT'=>			'J M j H:i',
 	'S_ADD_SMALL'=>			'追加',
 	'S_ERROR_ADDING_SERVICE_TIME'=>			'サービス時間のエラー',
 	'S_IS_A_WRONG_TIME_FORMAT'=>			'は正しくない時間の形式です。00:00から24:00の間で設定してください。',
@@ -1329,10 +1329,10 @@
 	'S_NOTIFICATIONS'=>			'通知レポート',
 	'S_NOTIFICATIONS_BIG'=>			'通知レポート',
 	'S_IT_NOTIFICATIONS'=>			'通知レポート',
-	'S_REPORT4_ANNUALLY_DATE_FORMAT'=>			'Y',
-	'S_REPORT4_MONTHLY_DATE_FORMAT'=>			'Y M',
-	'S_REPORT4_DAILY_DATE_FORMAT'=>			'Y M d',
-	'S_REPORT4_WEEKLY_DATE_FORMAT'=>			'Y M d H:i',
+	'S_REPORT4_ANNUALLY_DATE_FORMAT'=>			'J',
+	'S_REPORT4_MONTHLY_DATE_FORMAT'=>			'J M',
+	'S_REPORT4_DAILY_DATE_FORMAT'=>			'J M j',
+	'S_REPORT4_WEEKLY_DATE_FORMAT'=>			'J M j H:i',
 	'S_TRIGGERS_TOP_100'=>			'障害発生数上位100項目',
 	'S_TRIGGERS_TOP_100_BIG'=>			'障害発生数上位100項目',
 	'S_NUMBER_OF_STATUS_CHANGES'=>			'ステータス変更の回数',
@@ -1349,7 +1349,7 @@
 	'S_PALETTE'=>			'パレット',
 	'S_DARKEN'=>			'暗く',
 	'S_BRIGHTEN'=>			'明るく',
-	'S_REPORTS_BAR_REPORT_DATE_FORMAT'=>			'Y M d H:i:s',
+	'S_REPORTS_BAR_REPORT_DATE_FORMAT'=>			'J M j H:i:s',
 	'S_SCREENS'=>			'スクリーン',
 	'S_SCREEN'=>			'スクリーン',
 	'S_CONFIGURATION_OF_SCREENS_BIG'=>			'スクリーンの設定',
@@ -1770,11 +1770,11 @@
 	'S_DISCOVERY_CHECKS_BIG'=>			'ディスカバリチェック',
 	'S_HOSTS_AND_TEMPLATES_BIG'=>			'ホストとテンプレート',
 	'S_CANNOT_SWITCH_HOSTS'=>			'現在選択しているホストにスイッチできません',
-	'S_POPUP_PERIOD_CAPTION_DATE_FORMAT'=>			'Y M d H:i:s',
+	'S_POPUP_PERIOD_CAPTION_DATE_FORMAT'=>			'J M j H:i:s',
 	'S_BLOCKS_SYSTEM_SUMMARY_TIME_FORMAT'=>			'H:i:s',
 	'S_BLOCKS_HOSTSTAT_SUMMARY_TIME_FORMAT'=>			'H:i:s',
 	'S_BLOCKS_ZBX_STATUS_TIME_FORMAT'=>			'H:i:s',
-	'S_BLOCKS_LATEST_ISSUES_DATE_FORMAT'=>			'Y M d H:i:s',
+	'S_BLOCKS_LATEST_ISSUES_DATE_FORMAT'=>			'J M j H:i:s',
 	'S_BLOCKS_LATEST_ISSUES_TIME_FORMAT'=>			'H:i:s',
 	'S_BLOCKS_WEBMON_TIME_FORMAT'=>			'H:i:s',
 	'S_BLOCKS_DISCOVERY_STATUS_TIME_FORMAT'=>			'H:i:s',
@@ -1966,7 +1966,7 @@
 	'S_DELETE_IT_Q'=>			'削除しますか？',
 	'S_THIS_SCREEN_ROW_NOT_EMPTY'=>			'スクリーンの行は空ではありません',
 	'S_THIS_SCREEN_COLUMN_NOT_EMPTY'=>			'スクリーンの列は空ではありません',
-	'S_SCREENS_PLAIN_TEXT_DATE_FORMAT'=>			'Y M d H:i:s',
+	'S_SCREENS_PLAIN_TEXT_DATE_FORMAT'=>			'J M j H:i:s',
 	'S_SCREENS_TRIGGER_FORM_DATE_FORMAT'=>			'[H:i:s]',
 	'S_NO_GRAPH_WITH'=>			'グラフのアイテムが存在しません',
 	'S_MISSING_ITEMS_FOR_GRAPH'=>			'グラフのアイテムが見つかりません',
@@ -1984,7 +1984,7 @@
 	'S_OF_EVERY_SMALL'=>			'of every',
 	'S_WEEKS_SMALL'=>			'週',
 	'S_WEEK_SMALL'=>			'週',
-	'S_MAINTENANCES_SCHEDULE_DATE_FORMAT'=>			'Y M d',
+	'S_MAINTENANCES_SCHEDULE_DATE_FORMAT'=>			'J M j',
 	'S_SERVICE_CANNOT_BE_PARENT_AND_CHILD_AT_THE_SAME_TIME'=>			'サービスは同時に親と子になることはできません',
 	'S_CANNOT_LINK_HARDLINKED_SERVICE'=>			'ハードリンクされたサービスにはリンクできません',
 	'S_CANNOT_LINK_SERVICE_TO_ITSELF'=>			'自身のサービスにはリンクできません',