diff -Nur php-orig/charts.php php/charts.php
--- php-orig/charts.php	2012-12-08 12:09:20.000000000 +0100
+++ php/charts.php	2013-06-13 14:14:03.000000000 +0200
@@ -114,7 +114,7 @@
 	$curl->removeArgument('stime');
 
 	ob_end_clean();
-	redirect($curl->getUrl());
+	redirect($curl->getFile());
 }
 
 ob_end_flush();
diff -Nur php-orig/include/classes/class.cbuttoncancel.php php/include/classes/class.cbuttoncancel.php
--- php-orig/include/classes/class.cbuttoncancel.php	2012-12-08 12:09:18.000000000 +0100
+++ php/include/classes/class.cbuttoncancel.php	2013-06-13 14:15:28.000000000 +0200
@@ -34,7 +34,7 @@
 			$url .= $value;
 		}
 		$uri = new Curl($url);
-		$url = $uri->getUrl();
+		$url = $uri->getFile();
 		return $this->setAttribute('onclick', "javascript: return redirect('".$url."');");
 	}
 }
diff -Nur php-orig/include/classes/class.cbuttonqmessage.php php/include/classes/class.cbuttonqmessage.php
--- php-orig/include/classes/class.cbuttonqmessage.php	2012-12-08 12:09:18.000000000 +0100
+++ php/include/classes/class.cbuttonqmessage.php	2013-06-13 14:15:11.000000000 +0200
@@ -71,7 +71,7 @@
 		if (isset($this->vars)) {
 			$link = $page['file'].'?'.$this->name.'=1'.$this->vars;
 			$url = new Curl($link);
-			$action = "redirect('".$url->getUrl()."')";
+			$action = "redirect('".$url->getFile()."')";
 		}
 		else {
 			$action = 'true';
diff -Nur php-orig/include/classes/screens/CScreenGraph.php php/include/classes/screens/CScreenGraph.php
--- php-orig/include/classes/screens/CScreenGraph.php	2012-12-08 12:09:18.000000000 +0100
+++ php/include/classes/screens/CScreenGraph.php	2013-06-13 14:14:55.000000000 +0200
@@ -113,7 +113,7 @@
 			}
 
 			$this->screenitem['url']->setArgument('name', $host['name'].': '.$graph['name']);
-			$this->screenitem['url'] = $this->screenitem['url']->getUrl();
+			$this->screenitem['url'] = $this->screenitem['url']->getFile();
 		}
 
 		// get time control
diff -Nur php-orig/include/func.inc.php php/include/func.inc.php
--- php-orig/include/func.inc.php	2013-06-13 12:58:51.000000000 +0200
+++ php/include/func.inc.php	2013-06-13 14:10:55.000000000 +0200
@@ -24,7 +24,7 @@
 	zbx_flush_post_cookies();
 	$curl = new Curl($url);
 	$curl->setArgument('sid', null);
-	header('Location: '.$curl->getUrl());
+	header('Location: '.$curl->getFile());
 	exit();
 }
 
@@ -1532,7 +1532,7 @@
 	$link->setArgument('sort', $tabfield);
 	$link->setArgument('sortorder', $sortorder);
 
-	$url = $link->getUrl();
+	$url = $link->getFile();
 
 	if ($page['type'] != PAGE_TYPE_HTML && defined('ZBX_PAGE_MAIN_HAT')) {
 		$script = "javascript: return updater.onetime_update('".ZBX_PAGE_MAIN_HAT."', '".$url."');";
@@ -1638,13 +1638,13 @@
 		$url = new Curl();
 		if ($startPage > 1) {
 			$url->setArgument('page', 1);
-			$pageline[] = new CLink('<< '._x('First', 'page navigation'), $url->getUrl(), null, null, true);
+			$pageline[] = new CLink('<< '._x('First', 'page navigation'), $url->getFile(), null, null, true);
 			$pageline[] = '&nbsp;&nbsp;';
 		}
 
 		if ($currentPage > 1) {
 			$url->setArgument('page', $currentPage - 1);
-			$pageline[] = new CLink('< '._x('Previous', 'page navigation'), $url->getUrl(), null, null, true);
+			$pageline[] = new CLink('< '._x('Previous', 'page navigation'), $url->getFile(), null, null, true);
 			$pageline[] = ' | ';
 		}
 
@@ -1658,7 +1658,7 @@
 			}
 			else {
 				$url->setArgument('page', $p);
-				$pagespan = new CLink($p, $url->getUrl(), null, null, true);
+				$pagespan = new CLink($p, $url->getFile(), null, null, true);
 			}
 
 			$pageline[] = $pagespan;
@@ -1671,14 +1671,14 @@
 			$pageline[] = ' | ';
 
 			$url->setArgument('page', $currentPage + 1);
-			$pageline[] = new CLink(_x('Next', 'page navigation').' >', $url->getUrl(), null, null, true);
+			$pageline[] = new CLink(_x('Next', 'page navigation').' >', $url->getFile(), null, null, true);
 		}
 
 		if ($p < $pagesCount) {
 			$pageline[] = '&nbsp;&nbsp;';
 
 			$url->setArgument('page', $pagesCount);
-			$pageline[] = new CLink(_x('Last', 'page navigation').' >>', $url->getUrl(), null, null, true);
+			$pageline[] = new CLink(_x('Last', 'page navigation').' >>', $url->getFile(), null, null, true);
 		}
 
 		$table = new CTable(null, 'paging');
diff -Nur php-orig/include/html.inc.php php/include/html.inc.php
--- php-orig/include/html.inc.php	2012-12-08 12:09:18.000000000 +0100
+++ php/include/html.inc.php	2013-06-13 14:16:43.000000000 +0200
@@ -266,7 +266,7 @@
 			$icon = new CIcon(
 				$_REQUEST['fullscreen'] ? _('Normal view') : _('Fullscreen'),
 				'fullscreen',
-				"document.location = '".$url->getUrl()."';"
+				"document.location = '".$url->getFile()."';"
 			);
 			break;
 		case 'menu':
diff -Nur php-orig/include/page_header.php php/include/page_header.php
--- php-orig/include/page_header.php	2012-12-08 12:09:18.000000000 +0100
+++ php/include/page_header.php	2013-06-13 14:17:01.000000000 +0200
@@ -221,7 +221,7 @@
 	$req = new CUrl();
 	$req->setArgument('print', null);
 
-	$link = new CLink(bold('&laquo;'._('BACK')), $req->getUrl(), 'small_font', null, 'nosid');
+	$link = new CLink(bold('&laquo;'._('BACK')), $req->getFile(), 'small_font', null, 'nosid');
 	$link->setAttribute('style', 'padding-left: 10px;');
 
 	$printview = new CDiv($link, 'printless');
@@ -237,7 +237,7 @@
 
 	$req = new CUrl($_SERVER['REQUEST_URI']);
 	$req->setArgument('print', 1);
-	$printview = new CLink(_('Print'), $req->getUrl(), 'small_font', null, 'nosid');
+	$printview = new CLink(_('Print'), $req->getFile(), 'small_font', null, 'nosid');
 
 	$page_header_r_col = array($help, '|', $support, '|', $printview);
 
diff -Nur php-orig/include/views/configuration.host.discovery.list.php php/include/views/configuration.host.discovery.list.php
--- php-orig/include/views/configuration.host.discovery.list.php	2012-12-08 12:09:17.000000000 +0100
+++ php/include/views/configuration.host.discovery.list.php	2013-06-13 14:16:01.000000000 +0200
@@ -44,7 +44,7 @@
 
 $sortLink = new CUrl();
 $sortLink->setArgument('hostid', $this->data['hostid']);
-$sortLink = $sortLink->getUrl();
+$sortLink = $sortLink->getFile();
 
 $discoveryTable->setHeader(array(
 	new CCheckBox('all_items', null, "checkAll('".$discoveryForm->getName()."', 'all_items', 'g_hostdruleid');"),
diff -Nur php-orig/include/views/configuration.item.prototype.list.php php/include/views/configuration.item.prototype.list.php
--- php-orig/include/views/configuration.item.prototype.list.php	2012-12-08 12:09:17.000000000 +0100
+++ php/include/views/configuration.item.prototype.list.php	2013-06-13 14:15:52.000000000 +0200
@@ -44,7 +44,7 @@
 
 $sortLink = new CUrl();
 $sortLink->setArgument('parent_discoveryid', $this->data['parent_discoveryid']);
-$sortLink = $sortLink->getUrl();
+$sortLink = $sortLink->getFile();
 
 $itemTable->setHeader(array(
 	new CCheckBox('all_items', null, "checkAll('".$itemForm->getName()."', 'all_items', 'group_itemid');"),
diff -Nur php-orig/include/views/configuration.triggers.list.php php/include/views/configuration.triggers.list.php
--- php-orig/include/views/configuration.triggers.list.php	2012-12-08 12:09:17.000000000 +0100
+++ php/include/views/configuration.triggers.list.php	2013-06-13 14:16:16.000000000 +0200
@@ -85,7 +85,7 @@
 	$link->setArgument('parent_discoveryid', $this->data['parent_discoveryid']);
 }
 $link->setArgument('hostid', $this->data['hostid']);
-$link = $link->getUrl();
+$link = $link->getFile();
 
 $triggersTable = new CTableInfo(_('No triggers defined.'));
 $triggersTable->setHeader(array(