diff -uNrp zabbix-1.8.16.orig/frontends/php/include/locales/ja_jp.inc.php zabbix-1.8.16/frontends/php/include/locales/ja_jp.inc.php
--- zabbix-1.8.16.orig/frontends/php/include/locales/ja_jp.inc.php	2013-08-19 13:27:41.694841905 +0900
+++ zabbix-1.8.16/frontends/php/include/locales/ja_jp.inc.php	2013-08-19 13:28:58.903583416 +0900
@@ -25,14 +25,14 @@
 
 	'S_DATE_FORMAT_YMDHMS'=>			'J M j H:i:s',
 	'S_HTML_CHARSET'=>			'UTF-8',
-	'S_YEAR_SHORT'=>			'y',
-	'S_MONTH_SHORT'=>			'm',
-	'S_WEEK_SHORT'=>			'w',
-	'S_DAY_SHORT'=>			'd',
-	'S_HOUR_SHORT'=>			'h',
-	'S_MINUTE_SHORT'=>			'm',
-	'S_SECOND_SHORT'=>			's',
-	'S_MILLISECOND_SHORT'=>			'ms',
+	'S_YEAR_SHORT'=>			'年',
+	'S_MONTH_SHORT'=>			'ヶ月',
+	'S_WEEK_SHORT'=>			'週間',
+	'S_DAY_SHORT'=>			'日',
+	'S_HOUR_SHORT'=>			'時間',
+	'S_MINUTE_SHORT'=>			'分',
+	'S_SECOND_SHORT'=>			'秒',
+	'S_MILLISECOND_SHORT'=>			'ミリ秒',
 	'S_WEEKDAY_SUNDAY_SHORT'=>			'日',
 	'S_WEEKDAY_MONDAY_SHORT'=>			'月',
 	'S_WEEKDAY_TUESDAY_SHORT'=>			'火',
@@ -200,8 +200,8 @@
 	'S_RULES'=>			'ルール',
 	'S_EXISTING'=>			'存在する場合',
 	'S_MISSING'=>			'存在しない場合',
-	'S_REFRESH_TIME_IN_SECONDS'=>			'リフレッシュ間隔',
-	'S_REFRESH_TIME_MULTIPLIER'=>			'リフレッシュ間隔の乗数',
+	'S_REFRESH_TIME_IN_SECONDS'=>			'リフレッシュ時間',
+	'S_REFRESH_TIME_MULTIPLIER'=>			'リフレッシュ時間の乗数',
 	'S_IMPORTED'=>			'インポート済み',
 	'S_SUCCESSEFULLY_SMALL'=>			'成功',
 	'S_FAILED_SMALL'=>			'失敗',
@@ -265,8 +265,8 @@
 	'S_TRIGGER_SEVERITY'=>			'トリガーの深刻度',
 	'S_TRIGGER_VALUE'=>			'トリガーの値',
 	'S_TIME_PERIOD'=>			'期間',
-	'S_MAINTENANCE_STATUS'=>			'メンテナンスの状態',
-	'S_MAINTENANCE_SMALL'=>			'メンテナンス',
+	'S_MAINTENANCE_STATUS'=>			'メインテナンスの状態',
+	'S_MAINTENANCE_SMALL'=>			'メインテナンス',
 	'S_MAX_VALUE_SMALL'=>			'最大値',
 	'S_MIN_VALUE_SMALL'=>			'最小値',
 	'S_TRIGGER_DESCRIPTION'=>			'トリガーの名前',
@@ -326,7 +326,7 @@
 	'S_CANNOT_DELETE_ACTION'=>			'アクションを削除できません',
 	'S_SEND_MESSAGE_TO'=>			'メッセージの送信先',
 	'S_RUN_REMOTE_COMMANDS'=>			'リモートでコマンド実行',
-	'S_DELAY'=>			'間隔',
+	'S_DELAY'=>			'遅延',
 	'S_SUBJECT'=>			'件名',
 	'S_RECOVERY_SUBJECT'=>			'リカバリの件名',
 	'S_DEFAULT_MESSAGE'=>			'デフォルトのメッセージ',
@@ -387,7 +387,7 @@
 	'S_GRADIENT_LINE'=>			'グラデーションライン',
 	'S_CUSTOM_GRAPHS'=>			'カスタムグラフ',
 	'S_GRAPHS_BIG'=>			'グラフ',
-	'S_PERIOD'=>			'期間',
+	'S_PERIOD'=>			'周期',
 	'S_FULLSCREEN'=>			'フルスクリーン',
 	'S_VIEW'=>			'ビュー',
 	'S_CCHARTS_TIMELINE_HOURS_FORMAT'=>			'H:i',
@@ -470,7 +470,7 @@
 	'S_CANNOT_UPDATE_IMAGE'=>			'イメージを更新できません',
 	'S_OTHER'=>			'その他',
 	'S_OTHER_PARAMETERS'=>			'その他のパラメータ',
-	'S_REFRESH_UNSUPPORTED_ITEMS'=>			'取得不可アイテムの更新間隔(秒)',
+	'S_REFRESH_UNSUPPORTED_ITEMS'=>			'取得不可アイテムの更新時間(秒)',
 	'S_CREATE_MEDIA_TYPE'=>			'メディアタイプの作成',
 	'S_CREATE_IMAGE'=>			'イメージの作成',
 	'S_WORKING_TIME'=>			'ワーキングタイム',
@@ -593,7 +593,7 @@
 	'S_PIE'=>			'円グラフ',
 	'S_EXPLODED'=>			'分解円グラフ',
 	'S_AGGREGATED'=>			'履歴データの表示',
-	'S_AGGREGATED_PERIODS_COUNT'=>			'過去に遡る期間',
+	'S_AGGREGATED_PERIODS_COUNT'=>			'過去に遡る周期',
 	'S_ADD_GRAPH_ITEMS'=>			'アイテムを1つ以上選択してください',
 	'S_TITLE'=>			'タイトル',
 	'S_PERCENTILE_LINE'=>			'パーセンタイルライン',
@@ -655,41 +655,41 @@
 	'S_HISTORY_LOG_ITEM_PLAINTEXT'=>			'Y-m-d H:i:s',
 	'S_HISTORY_PLAINTEXT_DATE_FORMAT'=>			'Y-m-d H:i:s',
 	'S_HISTORY_ITEM_DATE_FORMAT'=>			'JMj H:i:s',
-	'S_MAINTENANCE'=>			'メンテナンス',
-	'S_MAINTENANCE_ADDED'=>			'メンテナンスを追加しました',
-	'S_MAINTENANCE_UPDATED'=>			'メンテナンスを更新しました',
-	'S_MAINTENANCE_DELETED'=>			'メンテナンスを削除しました',
-	'S_DELETE_SELECTED_MAINTENANCE_PERIODS_Q'=>			'選択したメンテナンス期間を削除しますか？',
+	'S_MAINTENANCE'=>			'メインテナンス',
+	'S_MAINTENANCE_ADDED'=>			'メインテナンスを追加しました',
+	'S_MAINTENANCE_UPDATED'=>			'メインテナンスを更新しました',
+	'S_MAINTENANCE_DELETED'=>			'メインテナンスを削除しました',
+	'S_DELETE_SELECTED_MAINTENANCE_PERIODS_Q'=>			'選択したメインテナンス周期を削除しますか？',
 	'S_GROUP_OR_HOST_NEEDED'=>			'少なくとも1つのホストまたはグループを選択する必要があります',
-	'S_IN_MAINTENANCE'=>			'メンテナンス中',
-	'S_HOSTS_IN_MAINTENANCE'=>			'メンテナンス中のホスト',
-	'S_GROUPS_IN_MAINTENANCE'=>			'メンテナンス中のホストグループ',
-	'S_CANNOT_ADD_MAINTENANCE'=>			'メンテナンスを追加できません',
-	'S_CANNOT_UPDATE_MAINTENANCE'=>			'メンテナンスを更新できません',
-	'S_CANNOT_DELETE_MAINTENANCE'=>			'メンテナンスを削除できません',
-	'S_MAINTENANCE_PERIOD_LENGTH'=>			'メンテナンス期間',
-	'S_MAINTENANCE_PERIODS_BIG'=>			'メンテナンス期間',
-	'S_NEW_MAINTENANCE_PERIOD'=>			'メンテナンス期間の作成',
-	'S_EDIT_MAINTENANCE_PERIOD'=>			'メンテナンス期間の変更',
-	'S_CREATE_MAINTENANCE_PERIOD'=>			'メンテナンス期間の作成',
-	'S_MAINTENANCE_TYPE'=>			'メンテナンスタイプ',
+	'S_IN_MAINTENANCE'=>			'メインテナンス中',
+	'S_HOSTS_IN_MAINTENANCE'=>			'メインテナンス中のホスト',
+	'S_GROUPS_IN_MAINTENANCE'=>			'メインテナンス中のホストグループ',
+	'S_CANNOT_ADD_MAINTENANCE'=>			'メインテナンスを追加できません',
+	'S_CANNOT_UPDATE_MAINTENANCE'=>			'メインテナンスを更新できません',
+	'S_CANNOT_DELETE_MAINTENANCE'=>			'メインテナンスを削除できません',
+	'S_MAINTENANCE_PERIOD_LENGTH'=>			'メインテナンス周期',
+	'S_MAINTENANCE_PERIODS_BIG'=>			'メインテナンス周期',
+	'S_NEW_MAINTENANCE_PERIOD'=>			'メインテナンス周期の作成',
+	'S_EDIT_MAINTENANCE_PERIOD'=>			'メインテナンス周期の変更',
+	'S_CREATE_MAINTENANCE_PERIOD'=>			'メインテナンス周期の作成',
+	'S_MAINTENANCE_TYPE'=>			'メインテナンスタイプ',
 	'S_EXPIRED'=>			'期限切れ',
-	'S_APPROACHING'=>			'メンテナンス待ち',
+	'S_APPROACHING'=>			'メインテナンス待ち',
 	'S_WITH_DATA_COLLECTION'=>			'データ収集あり',
 	'S_NO_DATA_COLLECTION'=>			'データ収集なし',
-	'S_NORMAL_MAINTENANCE'=>			'メンテナンス中(データ収集あり)',
-	'S_NO_DATA_MAINTENANCE'=>			'メンテナンス中(データ収集なし)',
-	'S_DELETE_MAINTENANCE_PERIOD_Q'=>			'メンテナンス期間を削除しますか？',
+	'S_NORMAL_MAINTENANCE'=>			'メインテナンス中(データ収集あり)',
+	'S_NO_DATA_MAINTENANCE'=>			'メインテナンス中(データ収集なし)',
+	'S_DELETE_MAINTENANCE_PERIOD_Q'=>			'メインテナンス周期を削除しますか？',
 	'S_ACTIVE_SINCE'=>			'開始日時',
 	'S_ACTIVE_TILL'=>			'終了日時',
-	'S_PERIOD_TYPE'=>			'期間のタイプ',
+	'S_PERIOD_TYPE'=>			'周期のタイプ',
 	'S_SCHEDULE'=>			'スケジュール',
 	'S_DATE'=>			'日付',
 	'S_ONE_TIME_ONLY'=>			'一度限り',
 	'S_DAY_OF_WEEK'=>			'曜日',
 	'S_DAY_OF_MONTH'=>			'日',
-	'S_EVERY_DAY_S'=>			'繰返し間隔(日)',
-	'S_EVERY_WEEK_S'=>			'繰返し間隔(週)',
+	'S_EVERY_DAY_S'=>			'周期(日)',
+	'S_EVERY_WEEK_S'=>			'周期(週)',
 	'S_FIRST'=>			'第1週',
 	'S_SECOND'=>			'第2週',
 	'S_THIRD'=>			'第3週',
@@ -707,12 +707,12 @@
 	'S_OCTOBER'=>			'10月',
 	'S_NOVEMBER'=>			'11月',
 	'S_DECEMBER'=>			'12月',
-	'S_INCORRECT_MAINTENANCE_PERIOD'=>			'不正なメンテナンス期間',
-	'S_INCORRECT_MAINTENANCE_DATE'=>			'不正なメンテナンス日付',
-	'S_INCORRECT_MAINTENANCE_DAY_PERIOD'=>			'不正なメンテナンス日',
-	'S_INCORRECT_MAINTENANCE_WEEK_PERIOD'=>			'不正なメンテナンス週',
-	'S_INCORRECT_MAINTENANCE_MONTH_PERIOD'=>			'不正なメンテナンス月',
-	'S_INCORRECT_MAINTENANCE_DAYS_OF_WEEK'=>			'不正なメンテナンス曜日',
+	'S_INCORRECT_MAINTENANCE_PERIOD'=>			'不正なメインテナンス周期',
+	'S_INCORRECT_MAINTENANCE_DATE'=>			'不正なメインテナンス日付',
+	'S_INCORRECT_MAINTENANCE_DAY_PERIOD'=>			'不正なメインテナンス日',
+	'S_INCORRECT_MAINTENANCE_WEEK_PERIOD'=>			'不正なメインテナンス週',
+	'S_INCORRECT_MAINTENANCE_MONTH_PERIOD'=>			'不正なメインテナンス月',
+	'S_INCORRECT_MAINTENANCE_DAYS_OF_WEEK'=>			'不正なメインテナンス曜日',
 	'S_CONFIGURATION_OF_GROUPS'=>			'ホストグループの設定',
 	'S_DELETE_SELECTED_GROUP'=>			'選択したグループを削除しますか？',
 	'S_ENABLE_SELECTED_HOST_GROUPS'=>			'選択したホストグループを有効にしますか？',
@@ -766,7 +766,7 @@
 	'S_CONFIGURATION_OF_HOSTS'=>			'ホストの設定',
 	'S_CONFIGURATION_OF_TEMPLATES'=>			'テンプレートの設定',
 	'S_CONFIGURATION_OF_APPLICATIONS'=>			'アプリケーションの設定',
-	'S_CONFIGURATION_OF_MAINTENANCE_PERIODS'=>			'メンテナンス期間の設定',
+	'S_CONFIGURATION_OF_MAINTENANCE_PERIODS'=>			'メインテナンス周期の設定',
 	'S_HOST_GROUPS_BIG'=>			'ホストグループ',
 	'S_NO_HOST_GROUPS_DEFINED'=>			'ホストグループが設定されていません',
 	'S_NO_HOSTS_DEFINED'=>			'ホストが設定されていません',
@@ -910,7 +910,7 @@
 	'S_OOB_ROUTER'=>			'OOBルータ',
 	'S_DATE_HW_BUY'=>			'HW購入日',
 	'S_DATE_HW_INSTALL'=>			'HWインストール日',
-	'S_DATE_HW_EXPIRY'=>			'HWメンテナンス期限日',
+	'S_DATE_HW_EXPIRY'=>			'HWメインテナンス期限日',
 	'S_DATE_HW_DECOMM'=>			'HW使用停止日',
 	'S_SITE_STREET_1'=>			'サイトアドレス #1',
 	'S_SITE_STREET_2'=>			'サイトアドレス #2',
@@ -1091,7 +1091,7 @@
 	'S_ICON_PROBLEM'=>			'アイコン (障害)',
 	'S_ICON_OK'=>			'アイコン (正常)',
 	'S_ICON_UNKNOWN'=>			'アイコン (不明)',
-	'S_ICON_MAINTENANCE'=>			'アイコン (メンテナンス',
+	'S_ICON_MAINTENANCE'=>			'アイコン (メインテナンス',
 	'S_ICON_DISABLED'=>			'アイコン (無効)',
 	'S_LINK_STATUS_INDICATOR'=>			'状態識別用トリガー',
 	'S_CONFIGURATION_OF_NETWORK_MAPS'=>			'ネットワークマップの設定',
@@ -1103,7 +1103,7 @@
 	'S_COORDINATE_X'=>			'X座標',
 	'S_COORDINATE_Y'=>			'Y座標',
 	'S_CONNECTORS'=>			'コネクタ',
-	'S_MAINTENANCE_BIG'=>			'メンテナンス',
+	'S_MAINTENANCE_BIG'=>			'メインテナンス',
 	'S_NO_PERMISSIONS_OR_MAP_DOES_NOT_EXIST'=>			'権限がないか、マップが存在しません',
 	'S_IMAGE_IS_USED_IN_ZABBIX_MAP'=>			'イメージはZabbixマップに利用されています',
 	'S_EDIT_MAP_ELEMENT'=>			'マップのアイコンを修正',
@@ -1198,7 +1198,7 @@
 	'S_DASHBOARD_CONFIGURATION_BIG'=>			'ダッシュボードの設定',
 	'S_CONFIGURE'=>			'設定',
 	'S_SELECTED'=>			'選択',
-	'S_SHOW_HOSTS_IN_MAINTENANCE'=>			'メンテナンス中のホストを表示',
+	'S_SHOW_HOSTS_IN_MAINTENANCE'=>			'メインテナンス中のホストを表示',
 	'S_TRIGGERS_WITH_SEVERITY'=>			'表示するトリガーの深刻度',
 	'S_DASHBOARD_FILTER'=>			'ダッシュボードフィルタ',
 	'S_FAVOURITE_GRAPHS'=>			'お気に入りのグラフ',
@@ -1281,7 +1281,7 @@
 	'S_PROBLEMS'=>			'障害',
 	'S_PERCENTAGE'=>			'パーセント',
 	'S_SLA'=>			'SLA',
-	'S_HOUR'=>			'時間',
+	'S_HOUR'=>			'時',
 	'S_HOURS'=>			'時間',
 	'S_MINUTE'=>			'分',
 	'S_MINUTES'=>			'分',
@@ -1634,7 +1634,7 @@
 	'S_USERS_STATUS'=>			'ユーザの状態',
 	'S_NO_RIGHTS_DEFINED'=>			'権限が設定されていません',
 	'S_READ_ONLY'=>			'読込専用',
-	'S_READ_WRITE'=>			'読書可能',
+	'S_READ_WRITE'=>			'読み書き可能',
 	'S_DENY'=>			'拒否',
 	'S_HIDE'=>			'非表示',
 	'S_PASSWORD'=>			'パスワード',
@@ -1814,7 +1814,7 @@
 	'S_DELETE_SELECTED_APPLICATIONS'=>			'選択したアプリケーションを削除しますか？',
 	'S_CANNOT_CREATE_APPLICATION'=>			'アプリケーションを削除できません',
 	'S_INCORRECT_FIELDS_FOR_APPLICATIONS'=>			'アプリケーションの設定が間違っています',
-	'S_INCORRECT_TIME_PERIOD'=>			'期間が間違っています',
+	'S_INCORRECT_TIME_PERIOD'=>			'周期が間違っています',
 	'S_NO_ELEMENTS_SELECTED'=>			'要素が選択されていません！',
 	'S_REFRESHED_EVERY_SMALL'=>			'リフレッシュ',
 	'S_PAGE_RECEIVED_INCORRECT_DATA'=>			'不正なデータを受信しました',
@@ -2063,8 +2063,8 @@
 	'S_CUSER_ERROR_USER_UNABLE_RESTRICT_SELF_GUI_ACCESS_PART2'=>			'"',
 	'S_CUSER_ERROR_USER_CANT_DISABLE_SELF_PART1'=>			'ユーザは自身でアカウントを無効にできません。グループ "',
 	'S_CUSER_ERROR_USER_CANT_DISABLE_SELF_PART2'=>			'"',
-	'S_CUSER_ERROR_INCORRECT_TIME_PERIOD'=>			'誤った時間の間隔',
-	'S_CUSER_ERROR_WRONG_PERIOD_PART1'=>			'誤った期間 [',
+	'S_CUSER_ERROR_INCORRECT_TIME_PERIOD'=>			'誤った時間の周期',
+	'S_CUSER_ERROR_WRONG_PERIOD_PART1'=>			'誤った周期[',
 	'S_CUSER_ERROR_WRONG_PERIOD_PART2'=>			']',
 	'S_CUSER_ERROR_INTERNAL_ZABBIX_ERROR'=>			'Zabbix内部エラー',
 	'S_CMEDIATYPE_ERROR_WRONG_FIELD_FOR_MEDIATYPE'=>			'メディアタイプの設定が正しくありません',