--- zabbix-1.8.16/frontends/php/items.php.orig	2013-08-19 08:54:56.186246212 +0900
+++ zabbix-1.8.16/frontends/php/items.php	2013-08-19 16:13:03.383134953 +0900
@@ -142,6 +142,7 @@ switch($itemType) {
 
 		'trapper_hosts'=>	array(T_ZBX_STR, O_OPT,  null,  null,			'isset({save})&&isset({type})&&({type}==2)'),
 		'units'=>		array(T_ZBX_STR, O_OPT,  null,  null,		'isset({save})&&isset({value_type})&&'.IN('0,3','value_type')),
+		'nonlls'=>		array(T_ZBX_STR, O_OPT,  null,  null,		null),
 		'multiplier'=>		array(T_ZBX_INT, O_OPT,  null,  null,		null),
 		'delta'=>		array(T_ZBX_INT, O_OPT,  null,  IN('0,1,2'),	'isset({save})&&isset({value_type})&&'.IN('0,3','value_type')),
 
@@ -382,6 +383,9 @@ switch($itemType) {
 		$applications = get_request('applications',array());
 		$delay_flex = get_request('delay_flex',array());
 		$db_delay_flex = '';
+		$non_lastlogsize = get_request('nonlls');
+		if (isset($non_lastlogsize) && $non_lastlogsize == 'yes') $non_lastlogsize = 1;
+		else $non_lastlogsize = 0;
 
 		foreach($delay_flex as $num => $val){
 			$db_delay_flex .= $val['delay'].'/'.$val['period'].';';
@@ -447,7 +451,7 @@ switch($itemType) {
 			}
 
 			if($new_appid){
-				$result = smart_update_item($_REQUEST['itemid'],$item);
+				$result = smart_update_item($_REQUEST['itemid'],$item,$non_lastlogsize);
 			}
 
 			$result = DBend($result);
--- zabbix-1.8.16/frontends/php/include/forms.inc.php.orig	2013-08-19 08:55:48.061019663 +0900
+++ zabbix-1.8.16/frontends/php/include/forms.inc.php	2013-08-19 16:15:39.790011885 +0900
@@ -1968,7 +1968,6 @@ ITEM_TYPE_CALCULATED $key = ''; $params 
 		zbx_subarray_push($valueTypeVisibility, ITEM_VALUE_TYPE_UINT64, 'multiplier');
 		zbx_subarray_push($valueTypeVisibility, ITEM_VALUE_TYPE_UINT64, 'row_multiplier');
 
-
 		$row = new CRow(array(new CCol(S_UPDATE_INTERVAL_IN_SEC,'form_row_l'), new CCol(new CNumericBox('delay',$delay,5),'form_row_r')));
 		$row->setAttribute('id', 'row_delay');
 		$frmItem->addRow($row);
@@ -2104,6 +2103,13 @@ ITEM_TYPE_CALCULATED $key = ''; $params 
 		}
 		$frmItem->addRow(S_APPLICATIONS,$cmbApps);
 
+		$non_lastlogsize = new CCheckBox('nonlls', 'no');
+		$row = new CRow(array(new CCol(S_NOT_REREAD_LOGFILES, 'form_row_l'), new CCol($non_lastlogsize, 'form_row_r')));
+		$row->setAttribute('id', 'row_nonlls');
+		$frmItem->addRow($row);
+		zbx_subarray_push($typeVisibility, ITEM_TYPE_ZABBIX_ACTIVE, 'nonlls');
+		zbx_subarray_push($typeVisibility, ITEM_TYPE_ZABBIX_ACTIVE, 'row_nonlls');
+
 		$frmRow = array(new CButton('save',S_SAVE));
 		if(isset($_REQUEST['itemid'])){
 			array_push($frmRow,
--- zabbix-1.8.16/frontends/php/include/locales/en_gb.inc.php.orig	2013-08-19 16:15:57.278021197 +0900
+++ zabbix-1.8.16/frontends/php/include/locales/en_gb.inc.php	2013-08-19 16:16:25.080016086 +0900
@@ -2508,5 +2508,6 @@
 	'S_MAINTE_MONTHLY_WEEK' =>	'At %1$s:%2$s on %3$s %4$s of every %5$s',
 	'S_MAINTE_MONTHLY' =>	'At %1$s:%2$s on %3$s of every %4$s',
 
+	'S_NOT_REREAD_LOGFILES' =>	'not re-read logfile(s) after saving',
 );
 ?>
--- zabbix-1.8.16/frontends/php/include/locales/ja_jp.inc.php.orig	2013-08-19 16:14:10.872019969 +0900
+++ zabbix-1.8.16/frontends/php/include/locales/ja_jp.inc.php	2013-08-19 16:15:27.929327333 +0900
@@ -2168,5 +2168,6 @@
 	'S_MAINTE_MONTHLY_WEEK' =>      '開始時刻 毎年%5$s %3$s %4$s %1$s:%2$s',
 	'S_MAINTE_MONTHLY' =>     '開始時刻 毎年%4$s %3$s日 %1$s:%2$s',
 
+	'S_NOT_REREAD_LOGFILES' =>	'保存後にログファイルの再読み込みをしない',
 	);
 ?>
--- zabbix-1.8.16/frontends/php/include/items.inc.php.orig	2013-08-19 16:07:23.780042775 +0900
+++ zabbix-1.8.16/frontends/php/include/items.inc.php	2013-08-19 15:42:32.081165394 +0900
@@ -492,7 +492,7 @@
 	 * Comments: !!! Don't forget sync code with C !!!                            *
 	 *                                                                            *
 	 ******************************************************************************/
-	function update_item($itemid, $item) {
+	function update_item($itemid, $item, $nonlls=0) {
 		$upd_app = (isset($item['applications']) && !is_null($item['applications']));
 		$item_in_params = $item;
 
@@ -576,7 +576,7 @@
 		}
 
 		$item_old = get_item_by_itemid($itemid);
-		DBexecute('UPDATE items SET lastlogsize=0, mtime=0 WHERE itemid='.$itemid.' AND key_<>'.zbx_dbstr($item['key_']));
+		if (0 == $nonlls) DBexecute('UPDATE items SET lastlogsize=0, mtime=0 WHERE itemid='.$itemid.' AND key_<>'.zbx_dbstr($item['key_']));
 
 		if($upd_app){
 			$result = DBexecute('DELETE FROM items_applications WHERE itemid='.$itemid);
@@ -651,7 +651,7 @@
  * Comments:
  *
  */
-	function smart_update_item($itemid, $item=array()){
+	function smart_update_item($itemid, $item=array(), $nonlls=0){
 		$item_data = get_item_by_itemid_limited($itemid);
 
 		$restore_rules= array(
@@ -699,7 +699,7 @@
 			}
 		}
 
-		return update_item($itemid,$item);
+		return update_item($itemid,$item,$nonlls);
 	}
 
 	/*